Name:           perl-Perl-Critic-Pulp
Version:        99
Release:    1%{?dist}
Summary:        Some add-on perlcritic policies
License:        GPL-3.0-or-later
URL:            https://metacpan.org/release/Perl-Critic-Pulp
Source0:        https://cpan.metacpan.org/authors/id/K/KR/KRYDE/Perl-Critic-Pulp-%{version}.tar.gz
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(base)
BuildRequires:  perl(constant)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(IO::String) >= 1.02
BuildRequires:  perl(List::MoreUtils) >= 0.24
BuildRequires:  perl(List::Util)
BuildRequires:  perl(Perl::Critic) >= 1.084
BuildRequires:  perl(Perl::Critic::Policy) >= 1.084
BuildRequires:  perl(Perl::Critic::Utils) >= 1.100
BuildRequires:  perl(Perl::Critic::Utils::PPI)
BuildRequires:  perl(Perl::Critic::Violation)
BuildRequires:  perl(Pod::Escapes)
BuildRequires:  perl(Pod::MinimumVersion) >= 50
BuildRequires:  perl(Pod::ParseLink)
BuildRequires:  perl(Pod::Parser)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(PPI) >= 1.220
BuildRequires:  perl(PPI::Document)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(vars)
BuildRequires:  perl(version)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(lib)
BuildRequires:  perl(PPI::Dumper)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(Perl::MinimumVersion)
Requires:       perl(IO::String) >= 1.02
Requires:       perl(List::MoreUtils) >= 0.24
Requires:       perl(Perl::Critic) >= 1.084
Requires:       perl(Pod::MinimumVersion) >= 50
Requires:       perl(PPI::Document)
Requires:       perl(Test::More)

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(List::MoreUtils\\)\\s*$
%global __requires_exclude %__requires_exclude|perl\\(Perl::Critic::Policy\\)\\s*$
%global __requires_exclude %__requires_exclude|perl\\(Perl::Critic::Utils\\)\\s*$
%global __requires_exclude %__requires_exclude|perl\\(Perl::Critic::Utils\\) >= 0\\.21$
%global __requires_exclude %__requires_exclude|perl\\(Perl::Critic::PodParser::ProhibitVerbatimMarkup\\)\\s*$
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}perl\\(Perl::MinimumVersion\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::PodParser::ProhibitVerbatimMarkup\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Policy::Documentation::ProhibitAdjacentLinks::Parser\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Pulp::PodMinimumVersionViolation\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Pulp::PodParser::ProhibitBadAproposMarkup\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Pulp::PodParser::ProhibitLinkToSelf\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Pulp::PodParser::ProhibitParagraphTwoDots\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Pulp::PodParser::ProhibitUnbalancedParens\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Pulp::PodParser::RequireLinkedURLs\\)\\s*$
%global __provides_exclude %__provides_exclude|perl\\(Perl::Critic::Pulp::ProhibitDuplicateHashKeys::Qword\\)\\s*$
%global __requires_exclude %__requires_exclude|perl\\(constant\\) >= 1\.
%global __requires_exclude %__requires_exclude|perl\\(:VERSION\\) >= 5\.10\.0$
%global __requires_exclude %__requires_exclude|perl\\(MyTestHelpers\\)
%global __provides_exclude %__provides_exclude|perl\\(MyTestHelpers\\)

%description
This is a collection of add-on policies for Perl::Critic.  They're under
a "pulp" theme plus other themes according to their purpose (see "POLICY
THEMES" in Perl::Critic).

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness
Requires:       perl(Data::Dumper)
Requires:       perl(PPI::Dumper)

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n Perl-Critic-Pulp-%{version}
chmod +x t/*.t t/ProhibitModuleShebang/Script.pl

%build
perl Makefile.PL INSTALLDIRS=perl NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="$RPM_OPT_FLAGS"
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license COPYING
%doc Changes README
%{perl_privlib}/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%changelog
* Thu Jun 20 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 99-1
- initial build
